/* AbiSource
 * 
 * Copyright (C) 2002 Dom Lachowicz <cinamod@hotmail.com>
 * Copyright (C) 2004 Robert Staudinger <robsta@stereolyzer.net>
 * Copyright (C) 2005 Daniel d'Andrada T. de Carvalho
 * <daniel.carvalho@indt.org.br>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA.
 */
 

#ifndef _OPENDOCUMENT_STREAM_LISTENER_H_
#define _OPENDOCUMENT_STREAM_LISTENER_H_

#include "ie_imp_OpenDocument.h"




/**
 * Baseclass for all OpenDocument listeners, basically a shim class
 * to expose a GetDocument() and a GetImporter() method
 */
class ABI_EXPORT OpenDocument_Stream_Listener : public virtual UT_XML::Listener
{
    
public:
  
    virtual ~OpenDocument_Stream_Listener () {}
    
    
private:
    IE_Imp_OpenDocument* m_pImporter;
  
protected:
    OpenDocument_Stream_Listener ( IE_Imp_OpenDocument* pImporter )
        : m_pImporter ( pImporter ) {}

    inline IE_Imp_OpenDocument* getImporter () const { return m_pImporter; }
    inline PD_Document* getDocument() const { return m_pImporter->getDocument(); }
};

#endif //_OPENDOCUMENT_STREAM_LISTENER_H_
